angular.module('koClassified.controllers.blog', [])

    /*----------------------------------------------------------------------------------***
     |
     |                         Blog Controller
     |
     ***--------------------------------------------------------------------------------***/
    .controller('blogController', ['$scope', '$ionicFilterBar', '$ionicModal', 'blogService', 'adsService', 'modalService',
                        function(   $scope,   $ionicFilterBar,   $ionicModal,   blogService,   adsService,   modalService) {

                $scope.keyword  = null;
                $scope.category = null;

                /* Resets all the filter parameters */
                $scope.resetFilters = function() {
                        $scope.category = {};
                        $scope.posts.load().then(function() {
                            $scope.posts.isLoading = false;
                        });
                };

                /* Initiate blog Service */
                $scope.posts = blogService;

                /* load Initial Data */
                $scope.posts.load().then(function() {
                        $scope.posts.isLoading = false;
                });
                adsService.loadSettings();

                /* function to be called for refresh */
                $scope.refresh = function() {
                        $scope.posts.refresh().then(function() {
                                $scope.$broadcast('scroll.refreshComplete');
                        });
                };

                /* function to be called on pagination */
                $scope.loadMore = function() {
                        if($scope.posts.isLoadingMore || !$scope.posts.hasMore) {
                                return false;
                        }
                        $scope.posts.nextPage().then(function(){
                                $scope.$broadcast('scroll.infiniteScrollComplete');
                        });
                };

                /*---------- Initializing Filter Bar  ------------*/
                $scope.showFilterBar = function () {
                        $ionicFilterBar.show({
                                externalScope : $scope,
                                FunctionToBeCalledOnChange : 'changed',
                                keyboardShowDelay : 300,
                                cancelText: 'بی خیال'
                        });
                };
                $scope.changed = function(value) {
                        $scope.keyword = value;
                };


                                /*-- set a category --*/
                $scope.setCategory = function(category) {
                     $scope.category = category;
                     $scope.categoriesModal.hide();
                };
                /*-- Reset Category --*/
                $scope.resetCategory = function() {
                        $scope.category = {};
                        $scope.categoriesModal.hide();
                };
                $scope.setSpecificCategory = function(category) {
                };

                // Watch Categories
                $scope.$watch('category', function(newValue, oldValue) {
                        if(newValue === oldValue){
                                return false;
                        }
                        $scope.posts.params.category = newValue.hasOwnProperty('ID') ? newValue.ID : null;
                        $scope.posts.load().then(function() {
                                $scope.posts.isLoading = false;
                        });
                });

                // watch keyword
                $scope.$watch('keyword', function(newValue, oldValue) {
                        if(newValue === oldValue){
                                return false;
                        }
                        console.log('yess');
                        $scope.posts.params.keyword = newValue;
                        $scope.posts.load().then(function() {
                                $scope.posts.isLoading = false;
                        });
                });


                $ionicModal.fromTemplateUrl('templates/modals/blogCategories.html', {
                        scope      : $scope,
                        "animation": "slide-in-up"
                }).then(function (modal) {
                        $scope.categoriesModal = modal
                });

                $scope.showCategoriesModal = function() {
                        $scope.posts.loadCategories().then(function (categories) {
                                $scope.categories = categories;
                        });
                        $scope.categoriesModal.show();
                };

                $scope.closeCategoriesModal = function() {
                    $scope.categoriesModal.hide();
                };
    }])


    /*----------------------------------------------------------------------------------***
     |
     |                         post Detail Controller
     |
     ***--------------------------------------------------------------------------------***/
        .controller('blogDetailController', ['$scope', '$stateParams', '$cordovaSocialSharing', '$timeout', '$ionicPopup', 'blogService', 'blogFactory', 'APP_OPTIONS', '$rootScope',
                function( $scope,   $stateParams,   $cordovaSocialSharing,   $timeout,   $ionicPopup,   blogService,   blogFactory,   APP_OPTIONS,   $rootScope )
                {
                        var postId = $stateParams.id;
                        $scope.formData = {};

                        $rootScope.isTransparent = true;
                        $scope.showMessage = false;
                        $scope.message = null;

                        $scope.posts = blogService;
                        blogService.findWithId(postId).then(function(post) {
                                $scope.post = post;
                                $scope.images = blogService.images($scope.post.image);
                        });

                        /*
                         * Brings up the share action sheet with cordovaSocialSharing Plugin
                         */
                        $scope.share = function() {

                                if($scope.posts.isLoading) { return showMessage('لطفا منتظر بمانید', 1000); }

                                var message =  $scope.post.TITLE + ' در ' + APP_OPTIONS.app_title + '\n';

                                $cordovaSocialSharing.share(message, null, null, $scope.post.link_to_post).then(function(result) {

                                });
                        };

                        $scope.goToLink = function(link) {
                                window.open(link, '_system');
                        };

                }]);
