angular.module('koClassified.controllers.pages', [])

.controller('pagesController', ['$scope', '$cordovaToast', 'navigationService', 'pagesFactory', function($scope, $cordovaToast, navigationService, pagesFactory) {

    $scope.isLoading = true;

    pagesFactory.loadRules().then(function(result) {
        $scope.isLoading = false;
        if(result.status) {
            $scope.text = result.text;
        } else {
            $cordovaToast.showLongBottom(result.false);
        }
    });

    $scope.goBack = function() {
        navigationService.goBack();
    };

}])


/*----------------------------------------------------------------------------------***
 |
 |                              Contact Us Controller
 |
 ***---------------------------------------------------------------------------------***/
.controller('contactController', ['$scope', '$timeout', '$cordovaFileTransfer', '$cordovaFileOpener2', '$cordovaToast', 'navigationService', 'adsService',
  function($scope, $timeout, $cordovaFileTransfer, $cordovaFileOpener2, $cordovaToast, navigationService, adsService) {

    $scope.isLoading = true;
    $scope.adsService = adsService;

    adsService.loadSettings().then(function(data) {
        $scope.isLoading = false;
        $scope.settings = data;
    });

    $scope.goBack = function() {
        navigationService.go('app.list');
    };

    document.addEventListener('deviceready', function () {
        var url = "http://download.kodesign.ir/kodesign_classified_pioneer.apk";
        var targetPath = cordova.file.externalDataDirectory + url.split("/").pop();
        //openFile('file:///storage/emulated/0/Android/data/pioneer.kodesignClassified.android/files/kodesign_classified_pioneer.apk');
        $cordovaFileTransfer.download(url, targetPath, {}, true)
            .then(function(result) {
                console.log(result.nativeURL);
                openFile(result.nativeURL);
            }, function(err) {
                console.log('no');
                console.log(JSON.stringify(err));
            }, function (progress) {
                $timeout(function () {
                     $scope.downloadProgress = (progress.loaded / progress.total) * 100;
                     console.log('progress:' + $scope.downloadProgress + ' %');
                }, 100);
        });
    });

    var openFile = function(url) {
      $cordovaFileOpener2.open(
        url,
        'application/vnd.android.package-archive'
      ).then(function() {
        alert('yes');
      }, function(err) {
        alert('no');
        console.log(JSON.stringify(err));
      });
    };

}])


/*----------------------------------------------------------------------------------***
 |
 |                              Notification Controller
 |
 ***---------------------------------------------------------------------------------***/
.controller('notificationController', ['$scope', '$stateParams', 'navigationService', 'notificationService', function($scope, $stateParams, navigationService, notificationService) {
    var notification_id = $stateParams.id;
    $scope.notification = notificationService.get(parseInt(notification_id));

    notificationService.makeWatched($scope.notification);
    $scope.goBack = function() {
      navigationService.go('app.list');
    };
}])

/*----------------------------------------------------------------------------------***
 |
 |                              Pricing Controller
 |
 ***---------------------------------------------------------------------------------***/
.controller('pricingController', ['$scope', 'navigationService', 'adsService', function($scope, navigationService, adsService) {

    $scope.adsService = adsService;
    if(adsService.plans.length === 0) {
        adsService.loadPlans().then(function (plans) {
            $scope.plans = plans;
        });
    } else {
        $scope.plans = adsService.plans;
    }

    $scope.goBack = function() {
        navigationService.go('app.list');
    };

}]);
