angular.module('koClassified.factories.blog', [])

  .factory('blogFactory', ['$http', '$q', '$cordovaFileTransfer', 'APP_OPTIONS',
                function ( $http,   $q,   $cordovaFileTransfer,   APP_OPTIONS)
  {
      var factory = {};

      /*
       * Returns the list of ads with defined parameters
       *
       * @params Object : object of filter parameters
       */
      factory.getPosts = function (params) {
          var defered = $q.defer();
          var data    = params || {};
          $http({
              method: "get",
              url   : APP_OPTIONS.api_base + '/blog',
              params: {
                action: "get",
                data  : data
              }
          }).success(function (data) {
              defered.resolve(data);
          }).error(function () {
              defered.reject('Error Accoured');
          });

          return defered.promise;
      };

      /**
       * Loads the ads with the given id
       * @param id
       * @returns {*}
       */
      factory.findById = function(id) {
          var defered = $q.defer();

          $http({
              method: "get",
              url   : APP_OPTIONS.api_base + '/blog/by-id',
              params: {
                action: "get",
                data  : { id: id }
              }
          }).success(function (data) {
              defered.resolve(data);
          }).error(function () {
              defered.reject('Error Accoured');
          });

          return defered.promise;
      };


      /*
       * Returns the list of all categories
       */
      factory.getCategories = function () {
        var defered = $q.defer();

        $http.get(APP_OPTIONS.api_base + '/blog/categories')
          .success(function (data) {
            defered.resolve(data);
          })
          .error(function () {
            defered.reject('Error Accoured');
          });

        return defered.promise;
      };

      return factory;

  }]);
